/*
 * Sponsored License - for use in support of a program or activity
 * sponsored by MathWorks.  Not for government, commercial or other
 * non-sponsored organizational use.
 *
 * mb_fm_mex_robotConstraint.cpp
 *
 * Code generation for function 'mb_fm_mex_robotConstraint'
 *
 */

/* Include files */
#include "mb_fm_mex_robotConstraint.h"

/* Function Definitions */
void mb_fm_mex_robotConstraint(const double [4], double states[4], double
  controls[2], double constraintvalue[2], double j_constraintvalue[20])
{
  int i0;
  signed char j_xOut[10];
  signed char j_vxOut[10];
  signed char j_yOut[10];
  signed char j_vyOut[10];
  signed char j_x[10];
  signed char j_vX[10];
  signed char j_y[10];
  signed char j_vY[10];
  signed char j_aX[10];
  signed char j_aY[10];
  double dv0[20];
  signed char b_j_xOut[100];
  int i1;
  double j_constraintvaluetmp[20];
  int i2;

  /* mb_fm_mex_robotConstraint */
  /*  File automatically generated by FALCON.m */
  /* === Extract Data From Input ============================================== */
  /* === Jacobians and Hessians =============================================== */
  for (i0 = 0; i0 < 10; i0++) {
    j_xOut[i0] = 0;
    j_vxOut[i0] = 0;
    j_yOut[i0] = 0;
    j_vyOut[i0] = 0;
    j_x[i0] = 0;
    j_vX[i0] = 0;
    j_y[i0] = 0;
    j_vY[i0] = 0;
    j_aX[i0] = 0;
    j_aY[i0] = 0;
  }

  j_xOut[0] = 1;
  j_vxOut[1] = 1;
  j_yOut[2] = 1;
  j_vyOut[3] = 1;
  j_x[4] = 1;
  j_vX[5] = 1;
  j_y[6] = 1;
  j_vY[7] = 1;
  j_aX[8] = 1;
  j_aY[9] = 1;

  /*  Combine Variables to outputs */
  /*  Combine Variables to states */
  /*  Combine Variables to controls */
  /* === Write Constants ====================================================== */
  /* === Call sys_5c56430ae8152e60b8293b5405d768ac ============================ */
  /* SYS_5C56430AE8152E60B8293B5405D768AC */
  /*     [OUT1,J_OUT1,H_OUT1] = SYS_5C56430AE8152E60B8293B5405D768AC(IN1,IN2,IN3) */
  /*     This function was generated by the Symbolic Math Toolbox version 8.0. */
  /*     12-Dec-2020 09:33:29 */
  constraintvalue[0] = (states[1] * states[1] + states[3] * states[3]) - 9.0;
  constraintvalue[1] = (controls[0] * controls[0] + controls[1] * controls[1]) -
    9.0;

  /*  Hessian Jacobian for sys_5c56430ae8152e60b8293b5405d768ac */
  /*  Calculation of Jacobian with respect to function global input for sys_5c56430ae8152e60b8293b5405d768ac */
  memset(&dv0[0], 0, 10U * sizeof(double));
  dv0[10] = states[1] * 2.0;
  dv0[11] = 0.0;
  dv0[12] = 0.0;
  dv0[13] = 0.0;
  dv0[14] = states[3] * 2.0;
  dv0[15] = 0.0;
  dv0[16] = 0.0;
  dv0[17] = controls[0] * 2.0;
  dv0[18] = 0.0;
  dv0[19] = controls[1] * 2.0;
  for (i0 = 0; i0 < 10; i0++) {
    b_j_xOut[10 * i0] = j_xOut[i0];
    b_j_xOut[1 + 10 * i0] = j_vxOut[i0];
    b_j_xOut[2 + 10 * i0] = j_yOut[i0];
    b_j_xOut[3 + 10 * i0] = j_vyOut[i0];
    b_j_xOut[4 + 10 * i0] = j_x[i0];
    b_j_xOut[5 + 10 * i0] = j_vX[i0];
    b_j_xOut[6 + 10 * i0] = j_y[i0];
    b_j_xOut[7 + 10 * i0] = j_vY[i0];
    b_j_xOut[8 + 10 * i0] = j_aX[i0];
    b_j_xOut[9 + 10 * i0] = j_aY[i0];
  }

  for (i0 = 0; i0 < 2; i0++) {
    for (i1 = 0; i1 < 10; i1++) {
      j_constraintvaluetmp[i0 + (i1 << 1)] = 0.0;
      for (i2 = 0; i2 < 10; i2++) {
        j_constraintvaluetmp[i0 + (i1 << 1)] += dv0[i0 + (i2 << 1)] * (double)
          b_j_xOut[i2 + 10 * i1];
      }
    }
  }

  /*  Combine Variables to constraintvalue */
  for (i0 = 0; i0 < 10; i0++) {
    j_constraintvalue[i0 << 1] = j_constraintvaluetmp[i0 << 1];
    j_constraintvalue[1 + (i0 << 1)] = j_constraintvaluetmp[1 + (i0 << 1)];
  }
}

void mb_fm_mex_robotConstraint_initialize()
{
}

void mb_fm_mex_robotConstraint_terminate()
{
  /* (no terminate code required) */
}

/* End of code generation (mb_fm_mex_robotConstraint.cpp) */
